=== debian/changelog ===
opencv (2.4.5+dfsg-0ubuntu4) saucy; urgency=low

  * Add libopencv-ocl-dev to depends of libopencv-dev

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 10 Oct 2013 16:58:42 +0100

opencv (2.4.5+dfsg-0ubuntu3) saucy; urgency=low

  [ Thomas Bleher ]
  * Package missing library libopencv-ocl LP: #1213861

  [ Jonathan Riddell ]
  * Add build-dep on ocl-icd-opencl-dev

 -- Thomas Bleher <ThomasBleher@gmx.de>  Mon, 19 Aug 2013 08:21:39 +0200

opencv (2.4.5+dfsg-0ubuntu2) saucy; urgency=low

  * Package missing library libopencv-superres

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 28 Jun 2013 14:01:14 +0100

opencv (2.4.5+dfsg-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 26 Jun 2013 16:44:16 +0100

opencv (2.4.3+dfsg-1) experimental; urgency=low

  * New upstream release.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 10 Dec 2012 01:01:14 +0900
